How to dfficiently re-start network

Hi,
In lab1 one uses the bootstrap script to start. Later on in the Lab there are docker-compose yml up commands, with new features like couchDB, chaincode, new peers etc.
Sometimes you have to restart the network (turned computer off, or edited yml-files). What is the common way to re-start your network? Do you start back at the bootstrap script, or how is this done by you?
Comments
-
Yes, I have also been wondering how to get back to the same state in a Hyperledger Fabric cluster? E.g. if you have couple of Chaincode instantiated, then there are some instances of containers running. How is this dealt in the production? I am sure there is easier way for this.
1 -
For those wondering the same, I just tweaked the start.sh & stop.sh scrips in the startFiles folder. Here you can decide which containers to start up so you dont have to type these commands manually each time you reboot computer.
0 -
However, as @maniankara asks, what about the created channels & chaincodes? Once I run docker-compose yml down & then up again (for instance if I needed to regenerate cryptomaterial), then suddenly all channels & chaincode needs to be re-installed again? If I run peer channel list the peers are not part of channels anymore....however, the artifacts are obviously still in the config folder.
So it seems this test network, the orderer, do not save its state?0 -
Yeah I asked myself the same question. Is there are special command to save the current state of Fabric? How are we supposed to do it in a production environment if the computer just shuts down? Do we have to start all over again?
0 -
Currently I just edited the bootstrap.sh to at least quickly bring up different containers, channels & chaincode. It is not ideal, but at least better than doing it all over again:
!/bin/sh
#
Copyright IBM Corp All Rights Reserved
#
SPDX-License-Identifier: Apache-2.0
#
export PATH=$GOPATH/src/github.com/hyperledger/fabric/build/bin:${PWD}/../bin:${PWD}:$PATH
export FABRIC_CFG_PATH=${PWD}
CHANNEL_NAME=allarewelcomeremove previous crypto material and config transactions
rm -fr config/*
rm -fr crypto-config/*
generate crypto material
cryptogen generate --config=./crypto-config.yaml
if [ "$?" -ne 0 ]; then
echo "Failed to generate crypto material..."
exit 1
fi
generate genesis block for orderer
configtxgen -profile OneOrgOrdererGenesis -outputBlock ./config/genesis.block
if [ "$?" -ne 0 ]; then
echo "Failed to generate orderer genesis block..."
exit 1
figenerate channel configuration transaction
configtxgen -profile OneOrgChannel -outputCreateChannelTx ./config/allarewelcome.tx -channelID allarewelcome
if [ "$?" -ne 0 ]; then
echo "Failed to generate channel configuration transaction..."
exit 1
figenerate anchor peer transaction
configtxgen -profile OneOrgChannel -outputAnchorPeersUpdate ./config/Org1MSPanchors.tx -channelID allarewelcome -asOrg Org1MSP
if [ "$?" -ne 0 ]; then
echo "Failed to generate anchor peer update for Org1MSP..."
exit 1
fisleep 5s
set -ev
don't rewrite paths for Windows Git Bash users
export MSYS_NO_PATHCONV=1
docker-compose -f docker-compose.yml down
docker-compose -f docker-compose.yml up -d zookeeper0.example.com zookeeper1.example.com zookeeper2.example.com kafka0.example.com kafka1.example.com
sleep 60s
docker-compose -f docker-compose.yml up -d Org1ca.example.com Org2ca.example.com orderer.example.com peer1.org1.example.com couchdbOrg1Peer1 couchdbOrg1Peer0 couchdbOrg2Peer0 couchdbOrg2Peer1 peer0.org1.example.com peer0.org2.example.com peer1.org2.example.com cli
wait for Hyperledger Fabric to start
incase of errors when running later commands, issue export FABRIC_START_TIMEOUT=
export FABRIC_START_TIMEOUT=10
echo ${FABRIC_START_TIMEOUT}
sleep ${FABRIC_START_TIMEOUT}
Create the channel
docker exec -e "CORE_PEER_LOCALMSPID=Org1MSP" -e "CORE_PEER_MSPCONFIGPATH=/etc/hyperledger/msp/users/[email protected]/msp" peer0.org1.example.com peer channel create -o orderer.example.com:7050 -c allarewelcome -f /etc/hyperledger/configtx/allarewelcome.tx
Join peer0.org1.example.com to the channel.
docker exec -e "CORE_PEER_LOCALMSPID=Org1MSP" -e "CORE_PEER_MSPCONFIGPATH=/etc/hyperledger/msp/users/[email protected]/msp" peer0.org1.example.com peer channel join -b allarewelcome.block
Peer1.org1 fetch genesis block from the channel before joining
docker exec -e "CORE_PEER_LOCALMSPID=Org1MSP" -e "CORE_PEER_MSPCONFIGPATH=/etc/hyperledger/msp/users/[email protected]/msp" peer1.org1.example.com peer channel fetch oldest allarewelcome.block -c allarewelcome --orderer orderer.example.com:7050
Join peer1.org1.example.com to the channel.
docker exec -e "CORE_PEER_LOCALMSPID=Org1MSP" -e "CORE_PEER_MSPCONFIGPATH=/etc/hyperledger/msp/users/[email protected]/msp" peer1.org1.example.com peer channel join -b allarewelcome.block
Install chaincode for peer0.org1 version 1.1 through CLI
docker exec -e "CORE_PEER_ADDRESS=peer0.org1.example.com:7051" -e "CORE_PEER_LOCALMSPID=Org1MSP" -e "CORE_PEER_MSPCONFIGPATH=/opt/gopath/src/github.com/hyperledger/fabric/peer/crypto/peerOrganizations/org1.example.com/users/[email protected]/msp" cli peer chaincode install -n ccForAll -v 1.1 -p github.com/sacc
Instantiate chaincode 1.1 on peer0.org1
docker exec -e "CORE_PEER_ADDRESS=peer0.org1.example.com:7051" -e "CORE_PEER_LOCALMSPID=Org1MSP" -e "CORE_PEER_MSPCONFIGPATH=/opt/gopath/src/github.com/hyperledger/fabric/peer/crypto/peerOrganizations/org1.example.com/users/[email protected]/msp" cli peer chaincode instantiate -n ccForAll -v 1.1 -o orderer.example.com:7050 -C allarewelcome -c '{"Args":["Mach","50"]}' --policy "AND('Org1.peer', OR ('Org1.member'))"
Sleep 10 sec for cc to install
sleep 10s
Try to sign config block for Org2 to join network through CLI
docker exec -e "CORE_PEER_LOCALMSPID=Org1MSP" -e "CORE_PEER_MSPCONFIGPATH=/opt/gopath/src/github.com/hyperledger/fabric/peer/crypto/peerOrganizations/org1.example.com/users/[email protected]/msp" -e "CORE_PEER_ADDRESS=peer0.org1.example.com:7051" cli peer channel signconfigtx -f org2submitReady.pb
Send config changes to rest of network for approval
docker exec -e "CORE_PEER_LOCALMSPID=Org1MSP" -e "CORE_PEER_MSPCONFIGPATH=/opt/gopath/src/github.com/hyperledger/fabric/peer/crypto/peerOrganizations/org1.example.com/users/[email protected]/msp" -e "CORE_PEER_ADDRESS=peer0.org1.example.com:7051" cli peer channel update -f org2submitReady.pb -c allarewelcome -o orderer.example.com:7050
Fetch config block allarewelcome for Peer0.org2
docker exec -e "CORE_PEER_LOCALMSPID=Org2MSP" -e "CORE_PEER_ADDRESS=peer0.org2.example.com:7051" -e "CORE_PEER_MSPCONFIGPATH=/opt/gopath/src/github.com/hyperledger/fabric/peer/crypto/peerOrganizations/org2.example.com/users/[email protected]/msp" cli peer channel fetch config Org2AddedConfig.pb -o orderer.example.com:7050 -c allarewelcome
Join channel allarewelcome for peer0.org2
docker exec -e "CORE_PEER_LOCALMSPID=Org2MSP" -e "CORE_PEER_ADDRESS=peer0.org2.example.com:7051" -e "CORE_PEER_MSPCONFIGPATH=/opt/gopath/src/github.com/hyperledger/fabric/peer/crypto/peerOrganizations/org2.example.com/users/[email protected]/msp" cli peer channel join -b allarewelcome.block
1 -
Hi guys, So there seems to be a lot of variations of the same question. So I'm going to try and condense them all into one and then answer that. The question seems to be
"Why are we using docker compose to restart the network every time we make docker-compose.yml config updates"
While this is a good question, I think we are missing the point. Docker compose is not a production grade tool, and should not be used in production grade environments. It is an amazing tool for most things leading up to it, development, testing etc. So we teardown and reboot the network with little to no effort. It's also what's used in conjunction with the docker-compose.yml file. It is a must learn/have for creating an environment for experimenting and learning for students (as well as development purposes).
How are we supposed to do it in a production environment if the computer just shuts down? Do we have to start all over again?
This question conflicts with the concept of decentralization. Remember that Fabric is not just running on a local machine, yet it's a network of hosts. So one host disconnecting from the network should not have any dire effect on the actual network itself (at Prod level).
In regard to the Bootstrap file...
The bootstrap file has nothing to do with the actual course. It was created only to jumpstart you into an preexisting, running (yet extremely basic) network, in which we scale from there. Everything done in that file is minuscule compared to what you actually do and learn throughout the labs, so I recommend to stop focusing on that, and more on that labs, because if you pay close attention to the labs, you will learn all of that anyway.1
Categories
- All Categories
- 51 LFX Mentorship
- 104 LFX Mentorship: Linux Kernel
- 576 Linux Foundation IT Professional Programs
- 304 Cloud Engineer IT Professional Program
- 125 Advanced Cloud Engineer IT Professional Program
- 53 DevOps Engineer IT Professional Program
- 61 Cloud Native Developer IT Professional Program
- 5 Express Training Courses
- 5 Express Courses - Discussion Forum
- 2K Training Courses
- 19 LFC110 Class Forum
- 7 LFC131 Class Forum
- 27 LFD102 Class Forum
- 158 LFD103 Class Forum
- 20 LFD121 Class Forum
- 1 LFD137 Class Forum
- 61 LFD201 Class Forum
- 1 LFD210 Class Forum
- LFD210-CN Class Forum
- 1 LFD213 Class Forum - Discontinued
- 128 LFD232 Class Forum
- LFD237 Class Forum
- 23 LFD254 Class Forum
- 611 LFD259 Class Forum
- 105 LFD272 Class Forum
- 1 LFD272-JP クラス フォーラム
- 1 LFD273 Class Forum
- 2 LFS145 Class Forum
- 24 LFS200 Class Forum
- 739 LFS201 Class Forum
- 1 LFS201-JP クラス フォーラム
- 11 LFS203 Class Forum
- 75 LFS207 Class Forum
- 300 LFS211 Class Forum
- 54 LFS216 Class Forum
- 47 LFS241 Class Forum
- 41 LFS242 Class Forum
- 37 LFS243 Class Forum
- 11 LFS244 Class Forum
- 37 LFS250 Class Forum
- 1 LFS250-JP クラス フォーラム
- LFS251 Class Forum
- 141 LFS253 Class Forum
- LFS254 Class Forum
- 1.1K LFS258 Class Forum
- 10 LFS258-JP クラス フォーラム
- 93 LFS260 Class Forum
- 132 LFS261 Class Forum
- 33 LFS262 Class Forum
- 80 LFS263 Class Forum
- 15 LFS264 Class Forum
- 11 LFS266 Class Forum
- 18 LFS267 Class Forum
- 17 LFS268 Class Forum
- 23 LFS269 Class Forum
- 203 LFS272 Class Forum
- 1 LFS272-JP クラス フォーラム
- LFS274 Class Forum
- LFS281 Class Forum
- 236 LFW211 Class Forum
- 172 LFW212 Class Forum
- 7 SKF100 Class Forum
- SKF200 Class Forum
- 903 Hardware
- 219 Drivers
- 74 I/O Devices
- 44 Monitors
- 116 Multimedia
- 209 Networking
- 101 Printers & Scanners
- 85 Storage
- 763 Linux Distributions
- 88 Debian
- 66 Fedora
- 15 Linux Mint
- 13 Mageia
- 24 openSUSE
- 142 Red Hat Enterprise
- 33 Slackware
- 13 SUSE Enterprise
- 357 Ubuntu
- 479 Linux System Administration
- 41 Cloud Computing
- 70 Command Line/Scripting
- Github systems admin projects
- 95 Linux Security
- 78 Network Management
- 108 System Management
- 49 Web Management
- 68 Mobile Computing
- 23 Android
- 30 Development
- 1.2K New to Linux
- 1.1K Getting Started with Linux
- 537 Off Topic
- 131 Introductions
- 217 Small Talk
- 21 Study Material
- 826 Programming and Development
- 278 Kernel Development
- 514 Software Development
- 928 Software
- 260 Applications
- 184 Command Line
- 3 Compiling/Installing
- 76 Games
- 316 Installation
- 61 All In Program
- 61 All In Forum
Upcoming Training
-
August 20, 2018
Kubernetes Administration (LFS458)
-
August 20, 2018
Linux System Administration (LFS301)
-
August 27, 2018
Open Source Virtualization (LFS462)
-
August 27, 2018
Linux Kernel Debugging and Security (LFD440)